/* ================================================================================ */
/*   driver/mcp3002.h                                                               */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__MCP3002_H__INCLUDED__
#define __DRIVER__MCP3002_H__INCLUDED__


	enum {
		MCP3002_SPIMODE				=	0
	} ;

	enum {
		MCP3002_MODE_SGL0			=	0x68,						/* Single-Ended Mode ch0        */
		MCP3002_MODE_SGL1			=	0x78,						/* Single-Ended Mode ch1        */
		MCP3002_MODE_DIFF0			=	0x48,						/* Pseudo-Differential Mode ch0 */
		MCP3002_MODE_DIFF1			=	0x58						/* Pseudo-Differential Mode ch1 */
	} ;


#define mcp3002_init				MCP3002_CS_HI
#define mcp3002_select()			MCP3002_MODE( SPI_MODE0 )

uint16_t mcp3002_read( uint8_t mode ) ;


#endif/*__DRIVER__MCP3002_H__INCLUDED__*/
