/* ================================================================================ */
/*   8052/depend.c                                                                  */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "mcp3002.h"
#include "mpl115a1.h"


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void rtos_init( void )
{
	/* hCo[ */
#ifdef  CONFIG_UART
	uart_init() ;
#endif/*CONFIG_UART*/

#ifdef  CONFIG_SDC
	sdc_init() ;
#endif/*CONFIG_SDC*/

#ifdef  CONFIG_MCP3002
	mcp3002_init() ;
#endif/*CONFIG_MCP3002*/

#ifdef  CONFIG_MPL115A1
	mpl115a1_init() ;
#endif/*CONFIG_MPL115A1*/
}


/* -------------------------------------------------------------------------------- */
/*   10us ҂                                                                      */
/*                                                                                  */
/*   IN : count = ҂                                                          */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void wait10us( uint16_t count ) __naked
{
	count = count ;

	__asm__(
	"	INC		DPH								\n"
	"wait10us_100:								\n"
	"	MUL		AB					; 4 cycle	\n"
	"	MUL		AB					; 4 cycle	\n"
	"	DJNZ	DPL, wait10us_100	; 2 cycle	\n"
	"	DJNZ	DPH, wait10us_100				\n"
	"	RET										\n"
	) ;
}
