; ================================================================================ 
;   dly_tsk.asm                                                                    
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module dly_tsk

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t dly_tsk( uint16_t dlytim ) ;                            
;                                                                  
;   IN : DPTR = dlytim                                             
;   OUT: DPL  = E_OK                                               
; ---------------------------------------------------------------- 
_dly_tsk::
	CLR	EA

	; R6R7 = dlytim
	MOV	R6, DPH
	MOV	R7, DPL

	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; ^C}[Cxgǉ
	MOV	A, #T_TCB_tim
	ADD	A, KNL_RUN_TCB
	MOV	R2, A
	MOV	R3, #TIM_EVT_NONE
	ACALL	KNL_ADD_TIM

	; s^XNXgO
	ACALL	KNL_DET_TCB_RUN

	; fBXpb`
	AJMP	KNL_DSP
