/* ================================================================================ */
/*   ezusb/i2c.h                                                                    */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __EZUSB__I2C_H__INCLUDED__
#define __EZUSB__I2C_H__INCLUDED__

	/* ߂l */
	enum {
		I2C_E_BUS					=	-97,							/* oXG[ */
		I2C_E_NACK					=	-98								/* ACK Ȃ   */
	} ;

	/* tO */
	enum {
		I2CINFO_FLAG_READ			=	1 << 0,						/* ǂݍ                           */
		I2CINFO_FLAG_WRITE			=	0 << 0,						/*                            */
		I2CINFO_FLAG_NOADDR			=	1 << 1,						/* X[uAhX𑗐MȂ       */
		I2CINFO_FLAG_NOSTOP			=	1 << 2						/* XgbvRfBV𐶐Ȃ */
	} ;

	/* I2C  */
	typedef struct {
		uint8_t						saddr ;							/* X[uAhX */
		uint8_t						flag ;							/* tO           */
		uint8_t						count ;							/* f[^         */
		const void __FAR			*p_data ;						/* f[^           */
	} I2CINFO ;


#define i2c_init()					{ EI2C = 1 ; }

extern int8_t i2c_send(uint8_t addr, const void __FAR *p_data, uint8_t count) ;
extern int8_t i2c_recv(uint8_t saddr, void __FAR *p_data, uint8_t count) ;
extern int8_t i2c_xfer(const I2CINFO __FAR *p_i2cInfo, uint8_t count) ;
extern void   i2c_isr( void ) INTPROC ;


#endif/*__EZUSB__I2C_H__INCLUDED__*/
