; ================================================================================ 
;   irot_rdq.asm                                                                   
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module irot_rdq

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t irot_rdq( uint8_t tskpro ) ;                            
;                                                                  
;   IN   : DPL = id                                                
;   OUT  : DPL = E_OK                                              
;                E_PAR                                             
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
_irot_rdq::
	MOV	A, DPL
	MOV	R7, A

	; if( tskpri == TPRI_SELF ) goto _irot_rdq_F80
	JZ	_irot_rdq_F80

	DEC	R7
_irot_rdq_100:
	; if( !KNL_TSK_PRI[R7] ) goto _irot_rdq_F00
	MOV	DPH, #(KNL_TSK_PRI >> 8)
	MOV	DPL, R7
	MOVX	A, @DPTR
	JZ	_irot_rdq_F00
	MOV	R6, A

	; if( !KNL_TSK_PRI[R6] ) goto _irot_rdq_F00
	MOV	DPL, A
	MOVX	A, @DPTR
	JZ	_irot_rdq_F00
	MOV	R5, A

	; KNL_TSK_PRI[R7] = R5
	MOV	DPL, R7
	MOV	A, R5
	MOVX	@DPTR, A

	; I[擾
_irot_rdq_140:
	MOV	DPL, R5
	MOVX	A, @DPTR
	JZ	_irot_rdq_180

	MOV	R5, A
	AJMP	_irot_rdq_140

_irot_rdq_180:
	MOV	A, R6
	MOVX	@DPTR, A

	; I[ݒ
	MOV	DPL, A
	CLR	A
	MOVX	@DPTR, A

	; fBXpb`\
	INC	KNL_INT_DSP

_irot_rdq_F00:
	MOV	DPL, #E_OK
	RET

_irot_rdq_F80:
	MOV	DPL, #E_PAR
	RET
