; ================================================================================ 
;   kernel.asm                                                                     
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.area	REG_BANK_0 (DATA,REL,OVR)
	.area	REG_BANK_1 (DATA,REL,OVR)
	.area	REG_BANK_2 (DATA,REL,OVR)
	.area	REG_BANK_3 (DATA,REL,OVR)
	.area	BSEG_BYTES (DATA,REL,CON)
	.area	BSEG       (DATA,BIT)
	.area	DSEG       (DATA,REL,CON)
	.area	OSEG       (DATA,REL,OVR)
	.area	ISEG       (DATA)
	.area	IABS       (DATA,ABS)
	.area	SSEG       (DATA,REL,OVR)
	.area	KNLINTVECT (CODE)
	.area	KNLISRPROC (CODE)
	.area	CSEGEVEN   (CODE)
	.area	KNLCTSK    (CODE)
	.area	KNLCSEM    (CODE)
	.area	KNLCCYC    (CODE)
	.area	KNLCODE    (CODE)
	.area	APICODE    (CODE)
	.area	CSEG       (CODE)
	.area	XINIT      (CODE,REL,CON)
	.area	CONST      (CODE,REL,CON)
	.area	KNLRES     (XDATA)
	.area	KNLSTK     (XDATA)
	.area	XSEG       (XDATA)
	.area	XISEG      (XDATA)


	.include "rtos.inc"
	.include "kernel.inc"


; ------------------------------------------------------------------------------------------------ 
;   荞݃xN^                                                                                 

	.area	KNLINTVECT (CODE)

RESET:
	LJMP	KNL_STARTUP




; ------------------------------------------------------------------------------------------------ 
;   J[lRtBM[V                                                                 

KNL_TSK_MAX		=	0				; ^XNő吔
KNL_SEM_MAX		=	0				; Z}tHő吔
KNL_CYC_MAX		=	0				; nhő吔
KNL_INH_MAX		=	0				; 荞݃nhő吔
KNL_USR_STKSZ		=	0				; [U[X^bNTCY
KNL_TSK_STKSZ		=	0				; ^XNX^bNTCY


	.include "kernel_cfg.asm"


	.area	KNLINTVECT  (CODE)
	.even




; ------------------------------------------------------------------------------------------------ 
;   R[ḧ                                                                                     

	.area	KNLISRPROC (CODE)

; ---------------------------------------------------------------- 
;   荞݃T[rX[`Ăяo                           
;                                                                  
;   IN   : KNL_INT_NO                                              
;   OUT  : Ȃ                                                    
;   BREAK: Ȃ                                                    
; ---------------------------------------------------------------- 
ISR_PROC:
	; R6R7 = 荞݃T[rX[`i[AhX
	POP	R6_B2
	POP	R7_B2

	PUSH	B
	PUSH	PSW
	PUSH	ACC
	PUSH	DPH
	PUSH	DPL
	KERNEL_CFG_ISR_ENTER

	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; WX^EoNQ
	MOV	PSW, #0x10

	; ߂AhX
	MOV	DPTR, #ISR_DSP
	PUSH	DPL
	PUSH	DPH

	; 荞݃T[rX[`Ăяo
	MOV	DPH, R6
	MOV	DPL, R7
	MOV	A, #1
	MOVC	A, @A+DPTR
	PUSH	ACC
	CLR	A
	MOVC	A, @A+DPTR
	PUSH	ACC
	RET


	.even


	.area	KNLCODE (CODE)

; ---------------------------------------------------------------- 
;   XDATA ̈NA                                             
;                                                                  
;   IN   : DPTR = AhX                                         
;          R0R1 = NA                                         
;   OUT  : Ȃ                                                    
;   BREAK: DPTR, R0, R1                                            
; ---------------------------------------------------------------- 
CLEAR_XDATA:
	MOV	A, R0
	ORL	A, R1
	JZ	CLEAR_XDATA_F00

	CLR	A
	INC	R0
INIT_KNLRES_100:
	MOVX	@DPTR, A
	INC	DPTR
	DJNZ	R1, INIT_KNLRES_100
	DJNZ	R0, INIT_KNLRES_100
CLEAR_XDATA_F00:
	RET


; ---------------------------------------------------------------- 
;   CODE  XDATA ֎woCgRs[                             
;                                                                  
;   IN   : R2R3 = Rs[AhX                                 
;          R4R5 = Rs[AhX                                 
;          R6R7 = Rs[oCg                                   
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R2, R3, R4, R5, R6, R7                         
; ---------------------------------------------------------------- 
COPY_CODE_XDATA:
	MOV	A, R6
	ORL	A, R7
	JZ	COPY_CODE_XDATA_F00

	INC	R6
COPY_CODE_XDATA_100:
	MOV	DPH, R2
	MOV	DPL, R3
	CLR	A
	MOVC	A, @A+DPTR
	INC	DPTR
	MOV	R2, DPH
	MOV	R3, DPL

	MOV	DPH, R4
	MOV	DPL, R5
	MOVX	@DPTR, A
	INC	DPTR
	MOV	R4, DPH
	MOV	R5, DPL

	DJNZ	R7, COPY_CODE_XDATA_100
	DJNZ	R6, COPY_CODE_XDATA_100

COPY_CODE_XDATA_F00:
	RET


; ---------------------------------------------------------------- 
;   CODE  DATA ֎woCgRs[                              
;                                                                  
;   IN   : DPTR = Rs[AhX                                 
;          R0   = Rs[AhX                                 
;          R1   = Rs[oCg                                   
;   OUT  : DPTR = Rs[AhX                                 
;          R0   = Rs[AhX                                 
;   BREAK: A, DPTR, R0, R1                                         
; ---------------------------------------------------------------- 
COPY_CODE_DATA:
	CLR	A
	MOVC	A, @A+DPTR
	INC	DPTR
	MOV	@R0, A
	INC	R0
	DJNZ	R1, COPY_CODE_DATA
	RET


; ---------------------------------------------------------------- 
;   N                                                           
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_STARTUP::
	MOV	SP, #KNL_STK-1

; ------------------------------------------------ 
;    RAM NA                                
; ------------------------------------------------ 
INIT_IRAM:
	CLR	A
	MOV	R0, #(l_IRAM-1)
INIT_IRAM_100:
	MOV	@R0, A
	DJNZ	R0, INIT_IRAM_100

; ------------------------------------------------ 
;   O RAM NA                                
; ------------------------------------------------ 
INIT_XSEG:
	MOV	R0, #(l_XSEG >> 8)
	MOV	R1, #l_XSEG
	MOV	DPTR, #s_XSEG
	ACALL	CLEAR_XDATA

; ------------------------------------------------ 
;   J[l\[ẌNA                     
; ------------------------------------------------ 
INIT_KNLRES:
	MOV	R0, #(l_KNLRES >> 8)
	MOV	R1, #l_KNLRES
	MOV	DPTR, #s_KNLRES
	ACALL	CLEAR_XDATA

; ------------------------------------------------ 
;   O RAM Rs[                                
; ------------------------------------------------ 
INIT_XISEG:
	MOV	R2, #(s_XINIT >> 8)
	MOV	R3, #s_XINIT
	MOV	R4, #(s_XISEG >> 8)
	MOV	R5, #s_XISEG
	MOV	R6, #(l_XINIT >> 8)
	MOV	R7, #l_XINIT
	ACALL	COPY_CODE_XDATA

; ------------------------------------------------ 
;   TCB 쐬                                       
; ------------------------------------------------ 
CREATE_TCB:
	MOV	DPTR, #s_KNLCTSK
	MOV	R2, #KNL_TCB
CREATE_TCB_100:
	; ^XN R3-R7 փRs[
	MOV	R0, #0x03
	MOV	R1, #0x05
	ACALL	COPY_CODE_DATA

	; R0R1 = DPTR
	MOV	R0, DPH
	MOV	R1, DPL

	; DPTR->tskpri = itskpri
	SET_m	R2, #T_TCB_tskpri
	MOV	A, R5
	MOVX	@DPTR, A

	; DPTR->stk = stk
	MOV_m	#(T_TCB_stk-T_TCB_tskpri)
	MOV	A, R7
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, R6
	MOVX	@DPTR, A

	; X^bNݒ
	MOV	DPH, R6						; DPTR = stk
	MOV	DPL, R7						
	MOV	A, #(KNL_USR_STK-1+2)				; DPTR[0] = SP
	MOVX	@DPTR, A					;
	INC	DPTR						;
	MOV	A, R4						; DPTR[1] = task
	MOVX	@DPTR, A					;
	INC	DPTR						;
	MOV	A, R3						;
	MOVX	@DPTR, A					;
	INC	DPTR						;
	CLR	A						; DPTR[3] = PSW(0x00)
	MOVX	@DPTR, A					;

	; ^XNt
	ACALL	KNL_ATT_TCB_PRI

	; DPTR = R0R1
	MOV	DPH, R0
	MOV	DPL, R1

	MOV	A, R2
	ADD	A, #T_TCB
	MOV	R2, A
	CJNE	A, #(KNL_TCB+(T_TCB*KNL_TSK_MAX)), CREATE_TCB_100

; ------------------------------------------------ 
;   Z}tH쐬                                   
; ------------------------------------------------ 
.if	ne, KNL_SEM_MAX
CREATE_SEM:
	MOV	DPTR, #s_KNLCSEM
	MOV	R2, #KNL_SEM
CREATE_SEM_100:
	; Z}tH R3-R4 փRs[
	MOV	R0, #0x03
	MOV	R1, #0x02
	ACALL	COPY_CODE_DATA

	; R0R1 = DPTR
	MOV	R0, DPH
	MOV	R1, DPL

	; DPTR->semcnt = isemcnt
	SET_m	R2, #T_SEM_semcnt
	MOV	A, R3
	MOVX	@DPTR, A

	; DPTR->maxsem = maxsem
	MOV_m	#(T_SEM_maxsem-T_SEM_semcnt)
	MOV	A, R4
	MOVX	@DPTR, A

	; DPTR = R0R1
	MOV	DPH, R0
	MOV	DPL, R1

	MOV	A, R2
	ADD	A, #T_SEM
	MOV	R2, A
	CJNE	R2, #(KNL_SEM+(T_SEM*KNL_SEM_MAX)), CREATE_SEM_100
.endif

; ------------------------------------------------ 
;   nh쐬                               
; ------------------------------------------------ 
.if	ne, KNL_CYC_MAX
CREATE_CYC:
	MOV	DPTR, #s_KNLCCYC
	MOV	R2, #KNL_CYC
CREATE_CYC_100:
	; nh R3-R7 փRs[
	MOV	R0, #0x03
	MOV	R1, #0x05
	ACALL	COPY_CODE_DATA

	; R0R1 = DPTR
	MOV	R0_B1, DPH
	MOV	R1_B1, DPL

	; DPTR->cycatr = cycatr
	SET_m	R2, #T_CYC_cycatr
	MOV	A, R3
	MOVX	@DPTR, A
	INC	DPTR

	; DPTR->cyctim = cyctim
	MOV	A, R7
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, R6
	MOVX	@DPTR, A

	; DPTR->tim.exinf = cychdr
	MOV_m	#(T_CYC_tim-(T_CYC_cyctim+1)+T_TIM_exinf)
	MOV	A, R5
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, R4
	MOVX	@DPTR, A

	; R2 = &R2->tim
	MOV	A, R2
	ADD	A, #T_CYC_tim
	MOV	R2, A

	; if( !(cycatr&TA_STA) ) goto CREATE_CYC_200
	MOV	A, R3
	ANL	A, #TA_STA
	JZ	CREATE_CYC_200

	; nhN
	MOV	R3, #TIM_EVT_CYC
	ACALL	ADD_TIM

CREATE_CYC_200:
	; DPTR = R0R1
	MOV	DPH, R0_B1
	MOV	DPL, R1_B1

	MOV	A, R2
	ADD	A, #(T_CYC-T_CYC_tim)
	MOV	R2, A
	CJNE	A, #(KNL_CYC+(T_CYC*KNL_CYC_MAX)), CREATE_CYC_100
.endif

	; ^C}[
	MOV	RCAP2H, #((65536-KERNEL_CFG_SIG_TIM) >> 8)
	MOV	RCAP2L, #((65536-KERNEL_CFG_SIG_TIM) >> 0)
	MOV	TH2, #((65536-KERNEL_CFG_SIG_TIM) >> 8)
	MOV	TL2, #((65536-KERNEL_CFG_SIG_TIM) >> 0)
	MOV	T2CON, #0x04
	SETB	ET2

	; s^XN TCB ݒ
	ACALL	SET_RUN_TCB
	MOV	R2, A

	; ʒm
	ACALL	_rtos_init

	; fBXpb`
	MOV	B, #0x00
	AJMP	DSP_300


; ---------------------------------------------------------------- 
;   ^XN ID ԍ^XNRg[ubN擾           
;                                                                  
;   IN   : R7   = ^XN ID ԍ                                 
;   OUT  : DPTR = ^XNRg[ubN                       
;          A    = ^XNRg[ubN                       
;   BREAK: A, B, DPTR                                              
; ---------------------------------------------------------------- 
KNL_GET_TCB::
	MOV	A, R7
	MOV	B, #T_TCB
	MUL	AB
	ADD	A, #(KNL_TCB-T_TCB)
	MOV	DPH, #(KNL_TCB >> 8)
	MOV	DPL, A
	RET


; ---------------------------------------------------------------- 
;   Z}tH ID ԍZ}tH擾                       
;                                                                  
;   IN   : R7   = Z}tH ID ԍ                               
;   OUT  : DPTR = Z}tH                                     
;          A    = Z}tH                                     
;   BREAK: A, DPTR                                                 
; ---------------------------------------------------------------- 
KNL_GET_SEM::
	MOV	A, R7
	RL	A
	ADD	A, R7
	ADD	A, #(KNL_SEM-T_SEM)
	MOV	DPH, #(KNL_SEM >> 8)
	MOV	DPL, A
	RET


; ---------------------------------------------------------------- 
;   nh ID ԍnh擾               
;                                                                  
;   IN   : R7   = nh ID ԍ                           
;   OUT  : DPTR = nh                                 
;          A    = nh                                 
;   BREAK: A, DPTR                                                 
; ---------------------------------------------------------------- 
KNL_GET_CYC::
	MOV	A, R7
	RL	A
	RL	A
	RL	A
	ADD	A, R7
	ADD	A, #(KNL_CYC-T_CYC)
	MOV	DPH, #(KNL_CYC >> 8)
	MOV	DPL, A
	RET


; ---------------------------------------------------------------- 
;   ^XNDxe[u֎t                               
;                                                                  
;   IN   : R2 = TCB *                                              
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R3                                             
; ---------------------------------------------------------------- 
KNL_ATT_TCB_PRI::
	; DPTR = &KNL_TSK_PRI[R2->tskpri]
	SET_m	R2, #T_TCB_tskpri
	MOVX	A, @DPTR
	MOV	DPL, A

; ---------------------------------------------------------------- 
;   TCB Xg֎t                                       
;                                                                  
;   IN   : DPTR = Xg                                           
;          R2   = TCB *                                            
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R3                                             
; ---------------------------------------------------------------- 
KNL_ATT_TCB::
	MOV	R3, DPL
KNL_ATT_TCB_100:
	; if( DPTR->next == 0 ) goto KNL_ATT_TCB_F00
	MOVX	A, @DPTR
	JZ	KNL_ATT_TCB_F00

	MOV	DPL, A
	AJMP	KNL_ATT_TCB_100

KNL_ATT_TCB_F00:
	MOV	A, R2
	MOVX	@DPTR, A

	; R2->next = 0
	SET_m	R2, #T_TCB_next
	CLR	A
	MOVX	@DPTR, A

	; R2->lst = R0
	MOV_m	#(T_TCB_lst-T_TCB_next)
	MOV	A, R3
	MOVX	@DPTR, A
	RET


; ---------------------------------------------------------------- 
;   s^XN TCB XgO                        
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : R2 = s^XN TCB                                 
;   BREAK: A, DPTR, R0, R, R2                                      
; ---------------------------------------------------------------- 
KNL_DET_TCB_RUN::
	MOV	R2, KNL_RUN_TCB

; ---------------------------------------------------------------- 
;   TCB XgO                                       
;                                                                  
;   IN   : R2 = TCB *                                              
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R0, R1                                         
; ---------------------------------------------------------------- 
KNL_DET_TCB::
	; R0 = R2->next
	SET_m	R2, #T_TCB_next
	MOVX	A, @DPTR
	MOV	R0, A

	; DPTR = R2->lst
	MOV_m	#(T_TCB_lst-T_TCB_next)
	MOVX	A, @DPTR
	MOV	DPL, A

KNL_DET_TCB_100:
	; if( *DPTR == R2 ) goto KNL_DET_TCB_F00
	MOVX	A, @DPTR
	MOV	R1, A
	CLR	C
	SUBB	A, R2
	JZ	KNL_DET_TCB_F00

	; DPTR = *DPTR
	MOV	DPL, R1
	AJMP	KNL_DET_TCB_100

KNL_DET_TCB_F00:
	; *DPTR = R0
	MOV	A, R0
	MOVX	@DPTR, A
	RET


; ---------------------------------------------------------------- 
;   ҂Ԃs\Ԃ֐ݒ                                 
;                                                                  
;   IN   : R2 = T_TCB *                                            
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_ACT_TSK::
	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; XgO
	ACALL	KNL_DET_TCB

	; ^XNDxe[u֎t
	ACALL	KNL_ATT_TCB_PRI

	; ^C}[Cxg폜
	ACALL	KNL_DEL_TSK_TIM

	; fBXpb`
	AJMP	KNL_DSP


; ---------------------------------------------------------------- 
;   ҂Ԃs\Ԃ֐ݒi荞݃nhpj           
;                                                                  
;   IN   : R2  = T_TCB *                                           
;   OUT  : EPL = E_OK                                              
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_IACT_TSK::
	; XgO
	ACALL	KNL_DET_TCB

	; ^XNDxe[u֎t
	ACALL	KNL_ATT_TCB_PRI

	; ^C}[Cxg폜
	ACALL	KNL_DEL_TSK_TIM

	; fBXpb`\
	INC	KNL_INT_DSP

	MOV	DPL, #E_OK
	RET


; ---------------------------------------------------------------- 
;   s\Ԃ҂Xg֐ڑ                               
;                                                                  
;   IN   : R2 = T_TCB *                                            
;          R3 = e[u                                           
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_WAI_TSK::
	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; XgO
	ACALL	KNL_DET_TCB

	; ^XNDxe[u֎t
	MOV	DPL, R3
	ACALL	KNL_ATT_TCB


	; fBXpb`
	AJMP	KNL_DSP


; ---------------------------------------------------------------- 
;   s\Ԃ҂Xg֐ڑi荞݃nhpj         
;                                                                  
;   IN   : R2  = T_TCB *                                           
;          R3  = e[u                                          
;   OUT  : DPL = E_OK                                              
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_IWAI_TSK::
	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; XgO
	ACALL	KNL_DET_TCB

	; ^XNDxe[u֎t
	MOV	DPL, R3
	ACALL	KNL_ATT_TCB

	; fBXpb`\
	INC	KNL_INT_DSP

	MOV	DPL, #E_OK
	RET


; ---------------------------------------------------------------- 
;   ^C}[Cxgǉ                                         
;                                                                  
;   IN   : R2   = T_TIM *                                          
;          R3   = ^C}[nhԍ                             
;          R6R7 =                                              
;   OUT  : DPTR = &R2->timhdr                                      
;   BREAK: A, DPTR, R0, R1, R3, R4, R5, R6, R7                     
; ---------------------------------------------------------------- 
KNL_ADD_TIM::
	; R6R7++
	INC	R7
	CJNE	R7, #0x00, ADD_TIM
	INC	R6

ADD_TIM:
	MOV	DPTR, #KNL_TIM_LST
	MOV	R4, DPL
ADD_TIM_100:
	; if( *DPTR == NULL ) goto ADD_TIM_F00
	MOVX	A, @DPTR
	MOV	R5, A
	JZ	ADD_TIM_F00

	; R0R1 = R5->reltim
	INC	A
	MOV	DPL, A
	MOVX	A, @DPTR
	INC	DPTR
	MOV	R1, A
	MOVX	A, @DPTR
	MOV	R0, A

	; if( R6R7 < R0R1 ) goto ADD_TIM_200
	SETB	C
	MOV	A, R1
	SUBB	A, R7
	MOV	R1, A
	MOV	A, R0
	SUBB	A, R6
	JNC	ADD_TIM_200

	; R6R7 = -AR1
	CPL	A
	MOV	R6, A
	MOV	A, R1
	CPL	A
	MOV	R7, A

	; DPL = R4 = R5
	MOV	A, R5
	MOV	R4, A
	MOV	DPL, A
	AJMP	ADD_TIM_100


ADD_TIM_200:
	; R0R1 = AR1 + 1
	MOV	R0, A
	MOV	A, #1
	ADD	A, R1
	MOV	R1, A
	CLR	A
	ADD	A, R0
	MOV	R0, A

	; R5->reltim = R0R1
	MOV	A, R5
	INC	A
	MOV	DPL, A
	MOV	A, R1
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, R0
	MOVX	@DPTR, A

ADD_TIM_F00:
	; R4->next = R2
	MOV	DPL, R4
	MOV	A, R2
	MOVX	@DPTR, A

	; R2->next = R5
	MOV	DPL, R2
	MOV	A, R5
	MOVX	@DPTR, A
	INC	DPTR

	; R4->reltim = R6R7
	MOV	A, R7
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, R6
	MOVX	@DPTR, A
	INC	DPTR

	; R4->timhdr = R3
	MOV	A, R3
	MOVX	@DPTR, A
	RET


; ---------------------------------------------------------------- 
;   ^XÑ^C}[Cxg폜                                 
;                                                                  
;   IN   : R2 = T_TCB *                                            
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R0, R1, R2, R3, R4                             
; ---------------------------------------------------------------- 
KNL_DEL_TSK_TIM:
	MOV	A, R2
	ADD	A, #T_TCB_tim
	MOV	R2, A

; ---------------------------------------------------------------- 
;   ^C}[Cxg폜                                         
;                                                                  
;   IN   : R2   = T_TIM *                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, DPTR, R0, R1, R3, R4                                 
; ---------------------------------------------------------------- 
KNL_DEL_TIM::
	; R0 = R2->next
	SET_m	R2, #T_TIM_next
	MOVX	A, @DPTR
	MOV	R0, A
	INC	DPTR

	; R3R4 = R2->reltim
	MOVX	A, @DPTR
	MOV	R4, A
	INC	DPTR
	MOVX	A, @DPTR
	MOV	R3, A
	INC	DPTR

	; if( R2->timhdr == TIM_EVT_UNUSED ) goto KNL_DEL_TIM_F00
	MOVX	A, @DPTR
	JZ	KNL_DEL_TIM_F00

	; R2->timhdr = TIM_EVT_UNUSED
	CLR	A
	MOVX	@DPTR, A

	; if( R0 == 0 ) goto KNL_DEL_TIM_100:
	MOV	A, R0
	JZ	KNL_DEL_TIM_100

	; R0->reltim += R3R4
	SET_m	R0, #T_TIM_reltim
	MOVX	A, @DPTR
	ADD	A, R4
	MOVX	@DPTR, A
	INC	DPTR
	MOVX	A, @DPTR
	ADDC	A, R3
	MOVX	@DPTR, A

	; PO擾
KNL_DEL_TIM_100:
	MOV	DPTR, #KNL_TIM_LST
KNL_DEL_TIM_180:
	; if( *DPTR == R2 ) goto KNL_DEL_TIM_200
	MOVX	A, @DPTR
	MOV	R1, A
	XRL	A, R2
	JZ	KNL_DEL_TIM_200

	MOV	DPL, R1
	AJMP	KNL_DEL_TIM_180

KNL_DEL_TIM_200:
	; DPTR->next = R0
	MOV	A, R0
	MOVX	@DPTR, A
KNL_DEL_TIM_F00:
	RET


; ---------------------------------------------------------------- 
;   s^XN TCB ݒ                                      
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : A = KNL_RUN_TCB                                         
;   BREAK: A, DPTR                                                 
; ---------------------------------------------------------------- 
SET_RUN_TCB:
	MOV	DPTR, #KNL_TSK_PRI
SET_RUN_TCB_100:
	MOVX	A, @DPTR
	INC	DPTR
	JZ	SET_RUN_TCB_100

	MOV	KNL_RUN_TCB, A
	RET


; ---------------------------------------------------------------- 
;   ^CAEg̃^C}[Cxg                             
;                                                                  
;   IN   : R2 = T_TIM *                                            
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
TIM_EVT_NONE_PROC:
	; fBXpb`\
	INC	KNL_INT_DSP

	; R2->tim.timhdr = TIM_EVT_UNUSED
	SET_m	R2, #T_TIM_timhdr
	MOV	A, #TIM_EVT_UNUSED
	MOVX	@DPTR, A

	; R2 = TCB *
	MOV	A, #-T_TCB_tim
	ADD	A, R2
	MOV	R2, A

	AJMP	KNL_ATT_TCB_PRI


; ---------------------------------------------------------------- 
;   ^CAEg̃^C}[Cxgi߂l E_TMOUTj           
;                                                                  
;   IN   : R2 = T_TIM *                                            
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
TIM_EVT_TMOUT_PROC:
	; fBXpb`\
	INC	KNL_INT_DSP

	; R2->tim.timhdr = TIM_EVT_UNUSED
	SET_m	R2, #T_TIM_timhdr
	MOV	A, #TIM_EVT_UNUSED
	MOVX	@DPTR, A

	; R2 = TCB *
	MOV	A, #-T_TCB_tim
	ADD	A, R2
	MOV	R2, A

	; DPTR = R2->T_TCB_result
	SET_m	R2, #T_TCB_result
	MOV	A, #E_TMOUT
	MOVX	@DPTR, A

	AJMP	KNL_ATT_TCB_PRI


; ---------------------------------------------------------------- 
;   Cxg̃^C}[Cxg                             
;                                                                  
;   IN   : R2 = T_TIM *                                            
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
TIM_EVT_CYC_PROC:
	; DPTR = R2->cyctim
	SET_m	R2, #(T_CYC_cyctim-T_CYC_tim)

	; R6R7 = DPTR->cyctim
	MOVX	A, @DPTR
	INC	DPTR
	MOV	R7, A
	MOVX	A, @DPTR
	MOV	R6, A

	; ^C}[Cxgǉ
	MOV	R3, #TIM_EVT_CYC
	ACALL	ADD_TIM

	; ֐ĂяoiDPTR->exinfj
	SET_m	R2, #T_TIM_exinf
	MOVX	A, @DPTR
	INC	DPTR
	PUSH	ACC
	MOVX	A, @DPTR
	PUSH	ACC
	RET


; ---------------------------------------------------------------- 
;   ^C}[Q荞݃T[rX[`                             
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: Ȃ                                                    
; ---------------------------------------------------------------- 
ISR_TIMER2:
	PUSH	B
	PUSH	PSW
	PUSH	ACC
	PUSH	DPH
	PUSH	DPL
	KERNEL_CFG_ISR_ENTER

	; eBbNJEgXV
ISR_TIMER2_000:
	CLR	A
	INC	_KNL_TICKCOUNT+0
	CJNE	A, _KNL_TICKCOUNT+0, ISR_TIMER2_040
	INC	_KNL_TICKCOUNT+1
	CJNE	A, _KNL_TICKCOUNT+1, ISR_TIMER2_040
	INC	_KNL_TICKCOUNT+2
	CJNE	A, _KNL_TICKCOUNT+2, ISR_TIMER2_040
	INC	_KNL_TICKCOUNT+3
ISR_TIMER2_040:

	; if( !KNL_TIM_LST ) goto ISR_TIMER2_100
	MOV	DPTR, #KNL_TIM_LST
	MOVX	A, @DPTR
	JZ	ISR_TIMER2_100

	; WX^EoNQ
	MOV	PSW, #0x10

	; DPTR = R2 = KNL_TIM_LST
	MOV	R2, A
	INC	A
	MOV	DPL, A

	; if( --DPTR->reltim ) goto ISR_TIMER2_100
	MOVX	A, @DPTR
	DEC	A
	MOVX	@DPTR, A
	JNZ	ISR_TIMER2_100
	INC	DPTR
	MOVX	A, @DPTR
	JZ	ISR_TIMER2_200

	DEC	A
	MOVX	@DPTR, A

ISR_TIMER2_100:
	KERNEL_CFG_ISR_LEAVE
	POP	DPL
	POP	DPH
	POP	ACC
	POP	PSW
	POP	B
	RETI


ISR_TIMER2_200:
	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; ߂AhX
	MOV	A, #ISR_TIMER2_380
	PUSH	ACC
	MOV	A, #(ISR_TIMER2_380 >> 8)
	PUSH	ACC

ISR_TIMER2_300:
	; R0 = R2->timhdr
	SET_m	R2, #T_TIM_timhdr
	MOVX	A, @DPTR
	MOV	R0, A

	; KNL_TIM_LST = R2->next
	MOV	DPL, R2
	MOVX	A, @DPTR
	MOV	DPL, #KNL_TIM_LST
	MOVX	@DPTR, A

	; TIM_EVT_TBL(R0)(R2)
	MOV	DPTR, #(TIM_EVT_TBL-2)
	MOV	A, R0
	JMP	@A+DPTR


TIM_EVT_TBL:
	AJMP	TIM_EVT_NONE_PROC
	AJMP	TIM_EVT_TMOUT_PROC
	AJMP	TIM_EVT_CYC_PROC


ISR_TIMER2_380:
	; if( !KNL_TIM_LST ) goto ISR_DSP
	MOV	DPTR, #KNL_TIM_LST
	MOVX	A, @DPTR
	JZ	ISR_DSP

	; R2 = KNL_TIM_LST
	MOV	R2, A
	INC	A
	MOV	DPL, A

	INC	SP
	INC	SP

	; if( R2->reltim ) goto ISR_TIMER2_300
	MOVX	A, @DPTR
	MOV	R0, A
	INC	DPTR
	MOVX	A, @DPTR
	ORL	A, R0
	JZ	ISR_TIMER2_300


; ---------------------------------------------------------------- 
;   荞ݒ̃fBXpb`                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
ISR_DSP:
	; fBXpb`\񂳂ĂȂȂI
	MOV	A, KNL_INT_DSP
	JZ	ISR_DSP_F00

	; fBXpb`\NA
	MOV	KNL_INT_DSP, #0x00

	; s^XN TCB ݒ
	MOV	R3, KNL_RUN_TCB
	ACALL	SET_RUN_TCB
	MOV	R2, A

	MOV	B, #0x80

	; s^XNςĂȂfBXpb`
	SUBB	A, R3
	JNZ	DSP

ISR_DSP_F00:
	; X^bN
	MOV	SP, KNL_USR_SP

	KERNEL_CFG_ISR_LEAVE
	POP	DPL
	POP	DPH
	POP	ACC
	POP	PSW
	POP	B
	RETI


; ---------------------------------------------------------------- 
;   API ̃fBXpb`                                         
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
KNL_DSP::
	; s^XN TCB ݒ
	MOV	R3, KNL_RUN_TCB
	ACALL	SET_RUN_TCB
	MOV	R2, A

	MOV	B, #E_OK

	; s^XNςĂȂfBXpb`
	SUBB	A, R3
	JNZ	DSP

	; ߂l
	MOV	DPL, #E_OK

	; X^bN
	MOV	SP, KNL_USR_SP

	; 荞݋
	SETB	EA
	RET


; ---------------------------------------------------------------- 
;   fBXpb`                                                   
;                                                                  
;   IN   : B = fBXpb`                                      
;   OUT  : Ȃ                                                    
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
DSP:
; ------------------------------------------------ 
;   ^XNX^bNޔ                             
; ------------------------------------------------ 
	; R3->result = B
	SET_m	R3, #T_TCB_result
	MOV	A, B
	MOVX	@DPTR, A
	INC	DPTR

	; DPTR = R3->stk
	MOVX	A, @DPTR
	INC	DPTR
	MOV	R0, A
	MOVX	A, @DPTR
	MOV	DPH, A
	MOV	DPL, R0

	; *DPTR++ = SP
	MOV	A, KNL_USR_SP
	MOVX	@DPTR, A
	INC	DPTR

	; R1 = ޔ
	MOV	R0, #KNL_USR_STK
	SUBB	A, R0
	INC	A
	MOV	R1, A

DSP_080:
	; *DPTR++ = *R0++
	MOV	A, @R0
	MOVX	@DPTR, A
	INC	DPTR
	INC	R0
	DJNZ	R1, DSP_080

	KERNEL_CFG_DSP_ENTER

	JNB	B.7, DSP_200

	; ------------------------------------------------ 
	;   荞݂ɂfBXpb`                     
	; ------------------------------------------------ 
DSP_100:
	; WX^ޔ
	MOV	R0, #0x00
	MOV	R1, #KERNEL_CFG_TSK_REG
DSP_180:
	MOV	A, @R0
	MOVX	@DPTR, A
	INC	DPTR
	INC	R0
	DJNZ	R1, DSP_180

	AJMP	DSP_300

	; ------------------------------------------------ 
	;   API ɂfBXpb`                         
	; ------------------------------------------------ 
DSP_200:
	; PSW ޔ
	MOV	A, PSW
	MOVX	@DPTR, A


; ------------------------------------------------ 
;   ^XNX^bN                             
; ------------------------------------------------ 
DSP_300:
	; R4 = R2->result
	SET_m	R2, #T_TCB_result
	MOVX	A, @DPTR
	MOV	R4, A
	INC	DPTR

	; DPTR = R2->stk
	MOVX	A, @DPTR
	INC	DPTR
	MOV	R0, A
	MOVX	A, @DPTR
	MOV	DPH, A
	MOV	DPL, R0

	; SP = *DPTR++
	MOVX	A, @DPTR
	MOV	SP, A
	INC	DPTR

	; R1 = ޔ
	MOV	R0, #KNL_USR_STK
	SUBB	A, R0
	INC	A
	MOV	R1, A

DSP_380:
	; *R0++ = *DPTR++
	MOVX	A, @DPTR
	MOV	@R0, A
	INC	DPTR
	INC	R0
	DJNZ	R1, DSP_380

	KERNEL_CFG_DSP_LEAVE

	CJNE	R4, #0x80, DSP_500

	; ------------------------------------------------ 
	;   荞݂ɂfBXpb`̕           
	; ------------------------------------------------ 
DSP_400:
	; WX^EoNQ
	MOV	PSW, #0x10

	; WX^
	MOV	R0, #0x00
	MOV	R1, #KERNEL_CFG_TSK_REG
DSP_440:
	; *R0++ = *DPTR++
	MOVX	A, @DPTR
	MOV	@R0, A
	INC	DPTR
	INC	R0
	DJNZ	R1, DSP_440

	KERNEL_CFG_ISR_LEAVE
	POP	DPL
	POP	DPH
	POP	ACC
	POP	PSW

	JB	B.7, DSP_4C0

	; API Ăяo
	POP	B

DSP_480:
	SETB	EA
	RET

DSP_4C0:
	; 荞݌Ăяo
	POP	B
	RETI

	; ------------------------------------------------ 
	;   API ɂfBXpb`̕               
	; ------------------------------------------------ 
DSP_500:
	; PSW = *DPTR
	MOVX	A, @DPTR
	MOV	R0, A
	MOV	A, R4
	MOV	PSW, A

	; ߂l
	MOV	DPL, A

	JNB	B.7, DSP_480

	RETI




; ------------------------------------------------------------------------------------------------ 
;   WX^oN                                                                                 

	.area	REG_BANK_0

R0_B0:		.DS	1				; [U[p
R1_B0:		.DS	1				;
R2_B0:		.DS	1				;
R3_B0:		.DS	1				;
R4_B0:		.DS	1				;
R5_B0:		.DS	1				;
R6_B0:		.DS	1				;
R7_B0:		.DS	1				;

	.area	REG_BANK_1

R0_B1:		.DS	1				; [U[piۑΏۊOj
R1_B1:		.DS	1				;
R2_B1:		.DS	1				;
R3_B1:		.DS	1				;
R4_B1:		.DS	1				;
R5_B1:		.DS	1				;
R6_B1:		.DS	1				;
R7_B1:		.DS	1				;

	.area	REG_BANK_2

R0_B2:		.DS	1				; J[lE荞ݗp
R1_B2:		.DS	1				;
R2_B2:		.DS	1				;
R3_B2:		.DS	1				;
R4_B2:		.DS	1				;
R5_B2:		.DS	1				;
R6_B2:		.DS	1				;
R7_B2:		.DS	1				;

	.area	REG_BANK_3

_KNL_TICKCOUNT::.DS	4				; eBbNJEg
KNL_RUN_TCB::	.DS	1				; s^XN TCB
KNL_USR_SP::	.DS	1				; [U[̃X^bN|C^
KNL_INT_DSP::						; 荞ݒ̃fBXpb`\
		.DS	1
R7_B3:		.DS	1				; gpie|ƂĎgpj




; ------------------------------------------------------------------------------------------------ 
;   X^bN                                                                                       

	.area	SSEG (DATA,REL,OVR)

KNL_STK::	.DS	KERNEL_CFG_STKSZ
KNL_USR_STK::	.DS	KNL_USR_STKSZ




; ------------------------------------------------------------------------------------------------ 
;   J[l\[X                                                                               

	.area	KNLRES (XDATA)

KNL_TSK_PRI::	.DS	KERNEL_CFG_TSK_PRI		; ^XNDxe[u
KNL_TIM_LST:	.DS	1				; ^C}[CxgXg
KNL_TCB:	.DS	T_TCB * KNL_TSK_MAX		; ^XNRg[ubN
KNL_SEM:	.DS	T_SEM * KNL_SEM_MAX		; Z}tH
KNL_CYC:	.DS	T_CYC * KNL_CYC_MAX		; nh


	.area	KNLSTK (XDATA)

KNL_TSK_STK:	.DS	KNL_TSK_STKSZ			; ^XNX^bN
