/* ================================================================================ */
/*   rtos.h                                                                         */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __RTOS__RTOS_H__INCLUDED__
#define __RTOS__RTOS_H__INCLUDED__

#ifdef  __cplusplus
extern "C" {
#endif/*__cplusplus*/


#include <stdint.h>
#include <8052.h>
#include "config.h"


#define nop()						__asm__("nop")
#define MSB( n )					(uint8_t )((uint16_t )(n) >> 8)
#define LSB( n )					(uint8_t )((uint16_t )(n) >> 0)

/*  */
#ifndef NULL
#define NULL						0
#endif/*NULL*/

#ifndef TRUE
#define TRUE						1
#endif/*TRUE*/

#ifndef FALSE
#define FALSE						0
#endif/*FALSE*/

#define E_OK						0						/* I */

/* IuWFNg */
#define TA_STA						0x02					/* nh𓮍삵ĂԂŐ */

/* ^CAEgw */
#define TMO_POL						0						/* |[O */
#define TMO_FEVR					-1						/* iv҂   */

/* ̑萔 */
#define TPRI_SELF					0						/* ^XÑx[XDx̎w */

/* G[R[h */
#define E_SYS						-5						/* VXeG[                   */
#define E_PAR						-17						/* p[^G[                 */
#define E_QOVR						-43						/* L[COI[o[t[       */
#define E_TMOUT						-50						/* |[Os܂̓^CAEg */


#define wai_sem( id )				(B = (id), _twai_sem( TMO_FEVR ))
#define pol_sem( id )				(B = (id), _twai_sem( TMO_POL ))
#define twai_sem(id, tmout)			(B = (id), _twai_sem( tmout ))
#define loc_cpu()					EA = 0
#define unl_cpu()					EA = 1


extern int8_t dly_tsk( uint16_t dlytim ) ;
extern int8_t sig_sem( uint8_t id ) ;
extern int8_t isig_sem( uint8_t id ) INTPROC ;
extern int8_t sta_cyc( uint8_t id ) ;
extern int8_t stp_cyc( uint8_t id ) ;
extern int8_t rot_rdq( uint8_t tskpro ) ;
extern int8_t irot_rdq( uint8_t tskpro ) INTPROC ;

extern int8_t _twai_sem( uint16_t tmout ) ;


#ifdef  __cplusplus
}
#endif/*__cplusplus*/

#endif/*__RTOS__RTOS_H__INCLUDED__*/
