/* ================================================================================ */
/*   driver/at24c.h                                                                 */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__AT24C_H__INCLUDED__
#define __DRIVER__AT24C_H__INCLUDED__


	enum {
		AT24C_SLAVE_ADDRESS			=	0x50						/* X[uJnAhX */
	} ;


extern int8_t at24c_read(uint8_t saddr, uint16_t daddr, void __FAR *p_data, uint8_t count) ;
extern int8_t at24c_cread(uint8_t saddr, void __FAR *p_data, uint8_t count) ;
extern int8_t at24c_write(uint8_t saddr, uint16_t daddr, const void __FAR *p_data, uint8_t count) ;


#endif/*__DRIVER__AT24C_H__INCLUDED__*/
