/* ================================================================================ */
/*   driver/mcp3002.c                                                               */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "mcp3002.h"


/* ---------------------------------------------------------------- */
/*   ǂݎ                                                       */
/*                                                                  */
/*   IN : mode = [hiMCP3002_MODE_xxxxj                        */
/*   OUT: l                                                        */
/* ---------------------------------------------------------------- */
uint16_t mcp3002_read( uint8_t mode )
{
	uint8_t		hi, lo ;


	MCP3002_CS_LO() ;

	hi = MCP3002_XFER( mode ) & 3 ;
	lo = MCP3002_XFER( 0x00 ) ;

	MCP3002_CS_HI() ;

	return (((uint16_t )hi<<8)|lo) ;
}
