/* ================================================================================ */
/*   driver/sdc.h                                                                   */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__SDC_H__INCLUDED__
#define __DRIVER__SDC_H__INCLUDED__


#define sdc_init()					SDC_CS_HI()
#define sdc_select()				{ SDC_MODE( SPI_MODE0 ) ;  SDC_XFER( 0xff ) ; }


extern int8_t sdc_reset( void ) ;
extern int8_t sdc_read(uint32_t address, uint8_t __FAR *p_data, uint8_t block) ;
extern int8_t sdc_write(uint32_t address, const uint8_t __FAR *p_data, uint8_t block) ;


#endif/*__DRIVER__SDC_H__INCLUDED__*/
