; ================================================================================ 
;   driver/usb.inc                                                                 
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 
; fBXNv^
DSCR_DEVICE			=	0x01			; foCX
DSCR_CONFIG			=	0x02			; RtBM[V
DSCR_STRING			=	0x03			; XgO
DSCR_INTERFACE			=	0x04			; C^tF[X
DSCR_ENDPOINT			=	0x05			; Gh|Cg
DSCR_DEVICEQUALIFIER		=	0x06			; foCXNHt@CA
DSCR_OTHERSPEEDCONFIG		=	0x07			;
DSCR_INTERFACEPOWER		=	0x08			;
DSCR_OTG			=	0x09			; OTG
DSCR_DEBUG			=	0x0a			; fobO
DSCR_INTERFACEASSOCIATION	=	0x0b			; C^tF[XA\VG[V
DSCR_HID			=	0x21			; HID
DSCR_HIDREPORT			=	0x22			; HID |[g
DSCR_CSINTERFACE		=	0x24			; NXŗL

; C^tF[XNXR[h
CLASS_NOSUB			=	0x00			; TuNXȂ */
CLASS_BOOTSUB			=	0x01			;
CLASS_HID			=	0x03			; HID NX
CLASS_VENDORSPEC		=	0xff			; x_L

; Gh|Cg
ET_CONTROL			=	0x00			; Rg[]
ET_ISO				=	0x01			; AC\NiX]
ET_BULK				=	0x02			; oN]
ET_INT				=	0x03			; C^vg]


; ---------------------------------------------------------------- 
;   Gh|Cg`                                           
;                                                                  
;   IN : num      = Gh|Cgԍƕ                       
;        type     = fBXNv^ށiET_xxxxj                  
;        size     = őpPbgTCY                             
;        interval = |[O                                 
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	ENDPOINT	num, type, size, interval
	.DB	7
	.DB	DSCR_ENDPOINT
	.DB	num
	.DB	type
	.DB	size
	.DB	size >> 8
	.DB	interval
	.endm
