:: ================================================================================ 
::   8052/mk.bat                                                                    
::                                                                                  
::   Copyright (C) 2014 lsluk, All rights reserved.                                 
::   http://www.geocities.jp/g_lsluk/index.html                                     
:: ================================================================================ 
@echo off
setlocal ENABLEDELAYEDEXPANSION


set AFLAGS=-goy -Imcs-51 -Idriver
set CFLAGS=-I. -Imcs-51 -Imcs-51/8052 -Idriver -Imw --debug --noinduction --nooverlay --model-small --opt-code-speed
set LDFLAGS=-imwyYM -I 0x100 -X 0x8000 -C 0x8000 -b KNLRES=0x8000 -S 1 -k "C:\Program Files\SDCC\lib\small" -l libint.lib -l liblong.lib


set rtos.lib_OBJS=mcs-51/dly_tsk.rel  ^
                  mcs-51/sig_sem.rel  ^
                  mcs-51/isig_sem.rel ^
                  mcs-51/twai_sem.rel ^
                  mcs-51/sta_cyc.rel  ^
                  mcs-51/stp_cyc.rel  ^
                  mcs-51/rot_rdq.rel  ^
                  mcs-51/irot_rdq.rel

set driver.lib_OBJS=driver/sc1602bs.rel ^
                    driver/mcp3002.rel  ^
                    driver/mpl115a1.rel ^
                    driver/sdc.rel      ^
                    mcs-51/uart.rel     ^
                    mcs-51/8052/spi.rel

set mw.lib_OBJS=mw/rsfat.rel

set OBJS=mcs-51/kernel.rel      ^
         mcs-51/8052/depend.rel ^
         app.rel

set LIBS=rtos.lib   ^
         driver.lib ^
         mw.lib

set TARGET=app.hex


call cscript //Nologo tool\build.js %1 %TARGET% %LIBS% %OBJS%
