; ================================================================================ 
;   isig_sem.asm                                                                   
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module isig_sem

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t isig_sem( uint8_t id ) ;                                
;                                                                  
;   IN   : DPL = id                                                
;   OUT  : DPL = E_OK                                              
;                E_QOVR                                            
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
_isig_sem::
	MOV	R7, DPL

	; Z}tH擾
	ACALL	KNL_GET_SEM

	; if( DPTR->waitsk ) { goto _isig_sem_100 ; }
	MOVX	A, @DPTR
	JNZ	_isig_sem_100

	; if( DPTR->semcnt == DPTR->maxcnt ) { return E_QOVR ; }
	MOV_m	#T_SEM_semcnt
	MOVX	A, @DPTR
	MOV	R0, A
	INC	DPTR
	MOVX	A, @DPTR
	XRL	A, R0
	JZ	_isig_sem_F00

	; DPTR->semcnt++
	MOV_m	#(T_SEM_semcnt-T_SEM_maxsem)
	MOV	A, R0
	INC	A
	MOVX	@DPTR, A

	; return E_OK
	MOV	DPL, #E_OK
	RET

_isig_sem_100:
	; s\Ԃ֐ݒ
	MOV	R2, A
	AJMP	KNL_IACT_TSK

_isig_sem_F00:
	MOV	DPL, #E_QOVR
	RET
