; ================================================================================ 
;   kernel.inc                                                                     
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

; ---------------------------------------------------------------- 
;   ^C}[Cxg                                               
; ---------------------------------------------------------------- 
TIM_EVT_UNUSED		=	0				; gp
TIM_EVT_NONE		=	2				; ^CAEgi߂lύXȂj
TIM_EVT_TMOUT		=	4				; ^CAEgi߂l ETMOUTj
TIM_EVT_CYC		=	6				; nh


; ---------------------------------------------------------------- 
;   ^XN}N                                               
;                                                                  
;   IN : tskid   = ^XN ID ԍiQƁj                      
;        task    = ^XN̋NԒn                                
;        itskpri = ^XN̋NDx                            
;        stksz   = ^XÑX^bN̈̃TCY                    
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	CRE_TSK	tskid, task, itskpri, stksz
	.globl	task
	.area	KNLCTSK (CODE)
	.DB	task >> 8
	.DB	task
	.DB	itskpri - 1
	.DB	(KNL_TSK_STK + KNL_TSK_STKSZ) >> 8
	.DB	(KNL_TSK_STK + KNL_TSK_STKSZ)
	KNL_TSK_MAX   = KNL_TSK_MAX   + 1
	KNL_TSK_STKSZ = KNL_TSK_STKSZ + stksz
	.if	lt, KNL_USR_STKSZ-stksz
		KNL_USR_STKSZ = stksz
	.endif
	.endm


; ---------------------------------------------------------------- 
;   Z}tH}N                                             
;                                                                  
;   IN : semid   = Z}tH ID ԍiQƁj                    
;        isemcnt = Z}tH̎̏l                        
;        maxsem  = Z}tH̍ő厑                            
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	CRE_SEM	semid, isemcnt, maxsem
	.area	KNLCSEM (CODE)
	.DB	isemcnt
	.DB	maxsem
	KNL_SEM_MAX = KNL_SEM_MAX + 1
	.endm


; ---------------------------------------------------------------- 
;   nh}N                                         
;                                                                  
;   IN : cycid  = nh ID ԍiQƁj                 
;        cycatr = nh̊g                           
;        cychdr = nh̋NԒn                           
;        cyctim = nh̋N                           
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	CRE_CYC	cycid, cycatr, cychdr, cyctim
	.globl	cychdr
	.area	KNLCCYC (CODE)
	.DB	cycatr
	.DB	cychdr >> 8
	.DB	cychdr
	.DB	cyctim >> 8
	.DB	cyctim
	KNL_CYC_MAX = KNL_CYC_MAX + 1
	.endm


; ---------------------------------------------------------------- 
;   ݃nh`}N                                       
;                                                                  
;   IN : inhno  = 荞݃xN^AhX                           
;        ext    = J[l̊ǗΏۂ 0:Ȃ, 1:            
;        inthdr = 荞݃nh̋NԒn                       
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	DEF_INH	inhno, ext, inthdr
	.area	KNLINTVECT (CODE)
	.bndry	inhno

	.narg	cnt

	.if	eq, cnt-2
		.if	eq, ext
			RETI
		.else
			CLR	TF2
			LJMP	ISR_TIMER2
		.endif
	.else
		.if	eq, ext
			LJMP	inthdr
		.else
			ACALL	ISR_PROC
			.DW	inthdr
		.endif
	.endif
	.endm


; ---------------------------------------------------------------- 
;   J[l\[X̃o[AhX DPTR ֐ݒ             
;                                                                  
;   IN   : p   = J[l\[X̃AhX                      
;          mem = o[ItZbg                                
;   OUT  : DPTR                                                    
;   BREAK: A, DPTR                                                 
; ---------------------------------------------------------------- 
	.macro	SET_m	p, mem
	MOV	DPH, #(s_KNLRES >> 8)
	.if	eq, mem
		MOV	DPL, p
		.mexit
	.endif

	.if	eq, mem-1
		MOV	DPL, p
		INC	DPTR
	.else
		MOV	A, p
		ADD	A, #mem
		MOV	DPL, A
	.endif
	.endm


; ---------------------------------------------------------------- 
;   J[l\[X̃o[AhXړ                     
;                                                                  
;   IN   : offset = ItZbg                                     
;   OUT  : DPTR                                                    
;   BREAK: A, DPTR                                                 
; ---------------------------------------------------------------- 
	.macro	MOV_m	offset
	.if	eq, offset
		.mexit
	.endif

	.if	eq, offset-1
		INC	DPTR
	.else
		MOV	A, DPL
		ADD	A, #offset
		MOV	DPL, A
	.endif
	.endm


; ---------------------------------------------------------------- 
;   gGfBAłQoCg`                             
;                                                                  
;   IN : value = l                                                
;   OUT: Ȃ                                                      
; ---------------------------------------------------------------- 
	.macro	.DWL	value
	.DB	(value)
	.DB	(value) >> 8
	.endm
