; ================================================================================ 
;   rot_rdq.asm                                                                    
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module rot_rdq

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t rot_rdq( uint8_t tskpro ) ;                             
;                                                                  
;   IN   : DPL = id                                                
;   OUT  : DPL = E_OK                                              
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
_rot_rdq::
	CLR	EA

	MOV	A, DPL
	MOV	R7, A
	DEC	R7

	; if( tskpri != TPRI_SELF ) goto _rot_rdq_100
	JNZ	_rot_rdq_100

	; ^XN̗Dx擾
	SET_m	KNL_RUN_TCB, #T_TCB_tskpri
	MOVX	A, @DPTR
	MOV	R7, A

_rot_rdq_100:
	; if( !KNL_TSK_PRI[R7] ) goto _rot_rdq_F00
	MOV	DPH, #(KNL_TSK_PRI >> 8)
	MOV	DPL, R7
	MOVX	A, @DPTR
	JZ	_rot_rdq_F00
	MOV	R6, A

	; if( !KNL_TSK_PRI[R6] ) goto _rot_rdq_F00
	MOV	DPL, A
	MOVX	A, @DPTR
	JZ	_rot_rdq_F00
	MOV	R5, A

	; KNL_TSK_PRI[R7] = R5
	MOV	DPL, R7
	MOV	A, R5
	MOVX	@DPTR, A

	; I[擾
_rot_rdq_140:
	MOV	DPL, R5
	MOVX	A, @DPTR
	JZ	_rot_rdq_180

	MOV	R5, A
	AJMP	_rot_rdq_140

_rot_rdq_180:
	MOV	A, R6
	MOVX	@DPTR, A

	; I[ݒ
	MOV	DPL, A
	CLR	A
	MOVX	@DPTR, A

	; X^bN؂ւ
	MOV	KNL_USR_SP, SP
	MOV	SP, #(KNL_STK-1)

	; fBXpb`
	AJMP	KNL_DSP


_rot_rdq_F00:
	MOV	DPL, #E_OK
	SETB	EA
	RET
