; ================================================================================ 
;   sta_cyc.asm                                                                    
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module sta_cyc

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t sta_cyc( uint8_t id ) ;                                 
;                                                                  
;   IN   : DPL = id                                                
;   OUT  : DPL = E_OK                                              
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
_sta_cyc::
	CLR	EA

	MOV	R7, DPL

	; nh擾
	ACALL	KNL_GET_CYC

	; if( DPTR->cycatr != 0 ) goto _sta_cyc_F00
	MOVX	A, @DPTR
	JNZ	_sta_cyc_F00

	; DPTR->cycatr = 1
	INC	A
	MOVX	@DPTR, A
	INC	DPTR

	; R6R7 = DPTR->cyctim
	MOVX	A, @DPTR
	MOV	R7, A
	INC	DPTR
	MOVX	A, @DPTR
	MOV	R6, A
	INC	DPTR

	; ^C}[Cxgǉ
	MOV	R2, DPL
	MOV	R3, #TIM_EVT_CYC
	ACALL	KNL_ADD_TIM

_sta_cyc_F00:
	MOV	DPL, #E_OK

	SETB	EA
	RET
