; ================================================================================ 
;   stp_cyc.asm                                                                    
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module stp_cyc

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t stp_cyc( uint8_t id ) ;                                 
;                                                                  
;   IN   : DPL = id                                                
;   OUT  : DPL = E_OK                                              
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
_stp_cyc::
	CLR	EA

	MOV	R7, DPL

	; nh擾
	ACALL	KNL_GET_CYC

	; if( DPTR->cycatr == 0 ) goto _stp_cyc_F00
	MOVX	A, @DPTR
	JZ	_stp_cyc_F00

	; DPTR->cycatr = 0
	CLR	A
	MOVX	@DPTR, A

	; ^C}[Cxg폜
	MOV	A, DPL
	ADD	A, #(T_CYC_tim-T_CYC_cycatr)
	MOV	R2, A
	ACALL	KNL_DEL_TIM

_stp_cyc_F00:
	MOV	DPL, #E_OK

	SETB	EA
	RET
