; ================================================================================ 
;   twai_sem.asm                                                                   
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module twai_sem

	.include "rtos.inc"
	.include "kernel.inc"


	.area	APICODE (CODE)


; ---------------------------------------------------------------- 
;   int8_t _twai_sem(uint8_t id, uint16_t tmout) ;                 
;                                                                  
;   IN   : B    = id                                               
;          DPTR = tmout                                            
;   OUT  : DPL  = E_OK                                             
;                 E_TMOUT                                          
;   BREAK: ALL                                                     
; ---------------------------------------------------------------- 
__twai_sem::
	CLR	EA

	MOV	R6, DPH
	MOV	R5, DPL
	MOV	R7, B

	; Z}tH擾
	ACALL	KNL_GET_SEM
	MOV	B, A

	; if( DPTR->semcnt ) { DPTR->semcnt-- ;  return E_OK ; }
	MOV_m	#T_SEM_semcnt
	MOVX	A, @DPTR
	JNZ	__twai_sem_F00

	; if( tmout == 0 ) { return E_TMOUT ; }
	MOV	A, R6
	ORL	A, R5
	JZ	__twai_sem_F40

	; if( tmout != 0xffff ) { KNL_ADD_TIM() }
	MOV	A, R6
	ANL	A, R5
	CPL	A
	JZ	__twai_sem_100

	MOV	A, R5
	MOV	R7, A

	; ^C}[Cxgǉ
	MOV	A, #T_TCB_tim
	ADD	A, KNL_RUN_TCB
	MOV	R2, A
	MOV	R3, #TIM_EVT_TMOUT
	ACALL	KNL_ADD_TIM

__twai_sem_100:
	; ҂Xg֐ڑ
	MOV	R2, KNL_RUN_TCB
	MOV	R3, B
	AJMP	KNL_WAI_TSK


__twai_sem_F00:
	DEC	A
	MOVX	@DPTR, A

	MOV	DPL, #E_OK
	SETB	EA
	RET

__twai_sem_F40:
	MOV	DPL, #E_TMOUT
	SETB	EA
	RET
