// ================================================================================ 
//   tool/build.js                                                                  
//                                                                                  
//   Copyright (C) 2014 lsluk, All rights reserved.                                 
//   http://www.geocities.jp/g_lsluk/index.html                                     
// ================================================================================ 

	var		m_fso, m_shell, m_aflags, m_cflags, m_ldflags, m_destPath, m_destName, m_destExt ;

	// 
	m_fso   = new ActiveXObject( "Scripting.FileSystemObject" ) ;
	m_shell = WScript.CreateObject( "WScript.Shell" ) ;

	WScript.Quit( main() ) ;


// -------------------------------------------------------------------------------- 
//   R}hCw肳ꂽt@CXVĂ邩ׂ                   
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: false == XVȂ                                                         
//        true  == XV                                                         
// -------------------------------------------------------------------------------- 
function IsUpdate()
{
	var		index, destFile ;

	// t@CȂȂXV
	if( m_fso.FileExists( m_destPath ) == false ) {
		return true ;
	}

	destFile = m_fso.GetFile( m_destPath ) ;

	for(index=1; index<WScript.Arguments.length; index++) {
		if( destFile.DateLastModified < m_fso.GetFile( WScript.Arguments( index ) ).DateLastModified ) {
			return true ;
		}
	}

	return false ;
}


// -------------------------------------------------------------------------------- 
//   R}hs                                                                 
//                                                                                  
//   IN : command = R}h                                                  
//   OUT: 0      == I                                                        
//        1      == ُI                                                        
// -------------------------------------------------------------------------------- 
function Exec( command )
{
	var		exec, stdout, string ;


	exec = m_shell.Exec( command ) ;

	while( !exec.StdOut.AtEndOfStream ) {
		string = exec.StdOut.ReadLine() ;

		if( string.substr(0, 11) != "ASlink >> -" ) {
			WScript.Echo( string ) ;
		}
	}

	while( !exec.StdErr.AtEndOfStream ) {
		string = exec.StdErr.ReadLine() ;

		if( string.substr(0, 11) != "ASlink >> -" ) {
			WScript.Echo( string ) ;
		}
	}

	return exec.ExitCode ;
}


// -------------------------------------------------------------------------------- 
//   Curh                                                             
//                                                                                  
//   IN : destPath = o͐t@C                                               
//   OUT: 0       == I                                                       
//        1       == ُI                                                       
// -------------------------------------------------------------------------------- 
function BuildLib( destPath )
{
	var		objs ;


	objs = m_shell.ExpandEnvironmentStrings( "%" + destPath + "_OBJS" + "%" ).replace(/[ \s]+/g, " ") ;

	return Exec( "cscript //Nologo tool\\build.js " + destPath + " " + objs ) ;
}


// -------------------------------------------------------------------------------- 
//   SDCC                                                                           
//                                                                                  
//   IN : destPath = o͐t@C                                               
//        srcePath = o͌t@C                                               
//   OUT: 0       == I                                                       
//        1       == ُI                                                       
// -------------------------------------------------------------------------------- 
function Sdcc(destPath, srcePath)
{
	// o͐̃t@CVȂ疳
	if( m_fso.FileExists( destPath ) != false ) {
		if( m_fso.GetFile( destPath ).DateLastModified >= m_fso.GetFile( srcePath ).DateLastModified ) {
			return 0 ;
		}
	}

	WScript.Echo( "  SDCC    " + destPath ) ;

	return Exec( "sdcc -mmcs51 -c " + m_cflags + " -o " + destPath + " " + srcePath ) ;
}


// -------------------------------------------------------------------------------- 
//   SDAS                                                                           
//                                                                                  
//   IN : destPath = o͐t@C                                               
//        srcePath = o͌t@C                                               
//   OUT: 0       == I                                                       
//        1       == ُI                                                       
// -------------------------------------------------------------------------------- 
function Sdas(destPath, srcePath)
{
	// o͐̃t@CVȂ疳
	if( m_fso.FileExists( destPath ) != false ) {
		if( m_fso.GetFile( destPath ).DateLastModified >= m_fso.GetFile( srcePath ).DateLastModified ) {
			return 0 ;
		}
	}

	WScript.Echo( "  SDAS    " + destPath ) ;

	return Exec( "sdas8051 " + m_aflags + " " + srcePath ) ;
}


// -------------------------------------------------------------------------------- 
//   O                                                                         
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 == I                                                             
//        1 == ُI                                                             
// -------------------------------------------------------------------------------- 
function Preprocess()
{
	var		index, destPath, destName, destExt ;


	for(index=1; index<WScript.Arguments.length; index++) {
		destPath = WScript.Arguments( index ) ;
		destExt  = m_fso.GetExtensionName( destPath ) ;
		destName = destPath.substr(0, destPath.length-destExt.length) ;

		if( destExt == "lib" ) {
			result = BuildLib( destPath ) ;
		} else
		if( destExt == "rel" ) {
			if( m_fso.FileExists( destName + "c" ) != false ) {
				result = Sdcc(destPath, destName+"c") ;
			} else
			if( m_fso.FileExists( destName + "asm" ) != false ) {
				result = Sdas(destPath, destName+"asm") ;
			} else {
				WScript.Echo( "target not found : " + destPath ) ;
				result = 1 ;
			}
		} else {
			WScript.Echo( "unsupported file : " + destPath ) ;
			result = 1 ;
		}

		if( result ) {
			return 1 ;
		}
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   ㏈                                                                         
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 == I                                                             
//        1 == ُI                                                             
// -------------------------------------------------------------------------------- 
function Postprocess()
{
	var		index, srcePath, libs, objs ;


	switch( m_destExt ) {
		case "lib":
		{
			// IuWFNgt@C
			objs = "" ;
			for(index=1; index<WScript.Arguments.length; index++) {
				objs += (" " + WScript.Arguments( index )) ;
			}

			WScript.Echo( "  SDCCLIB " + m_destPath ) ;

			result = Exec( "sdcclib r " + m_destPath + " " + objs ) ;
			break ;
		}

		case "hex":
		{
			// CuEIuWFNgt@C
			libs = "" ;
			objs = "" ;
			for(index=1; index<WScript.Arguments.length; index++) {
				srcePath = WScript.Arguments( index ) ;
				if( m_fso.GetExtensionName( srcePath ) == "lib" ) {
					libs += (" -l " + srcePath) ;
				} else {
					objs += (" " + srcePath) ;
				}
			}

			WScript.Echo( "  SDLD    " + m_destPath ) ;

			result = Exec( "sdld -n " + m_ldflags + libs + " " + m_destPath + objs ) ;
			if( result ) {
				break ;
			}

			m_fso.CopyFile(m_destPath.substr(0, m_destPath.length-3)+"ihx", m_destPath) ;
			break ;
		}

		default:
			result = 1 ;
			break ;
	}
}


// -------------------------------------------------------------------------------- 
//   rh                                                                     
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: s                                                                  
// -------------------------------------------------------------------------------- 
function Build()
{
	var		result ;

	// 
	m_aflags   = m_shell.ExpandEnvironmentStrings( "%AFLAGS%" ) ;
	m_cflags   = m_shell.ExpandEnvironmentStrings( "%CFLAGS%" ) ;
	m_ldflags  = m_shell.ExpandEnvironmentStrings( "%LDFLAGS%" ) ;
	m_destPath = WScript.Arguments( 0 ) ;
	m_destExt  = m_fso.GetExtensionName( m_destPath ) ;
	m_destName = m_destPath.substr(0, m_destPath.length-m_destExt.length) ;

	// O
	result = Preprocess() ;
	if( result ) {
		return result ;
	}

	// XVȂȂI
	if( IsUpdate() == false ) {
		return 0 ;
	}

	// ㏈
	result = Postprocess() ;
	if( result ) {
		return result ;
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   t@C폜                                                                 
//                                                                                  
//   IN : fileName = t@C                                                     
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function DeleteFile( fileName )
{
	if( m_fso.FileExists( fileName ) != false ) {
		m_fso.DeleteFile( fileName ) ;
	}
}


// -------------------------------------------------------------------------------- 
//   N[                                                                   
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: s                                                                  
// -------------------------------------------------------------------------------- 
function Clean()
{
	var		index, path, ext, name, objs ;


	for(index=1; index<WScript.Arguments.length; index++) {
		path = WScript.Arguments( index ) ;
		ext  = m_fso.GetExtensionName( path ) ;
		name = path.substr(0, path.length-ext.length) ;

		DeleteFile( path ) ;

		switch( ext ) {
			case "hex":
			{
				DeleteFile( name + "ihx" ) ;
				DeleteFile( name + "s19" ) ;
				DeleteFile( name + "cdb" ) ;
				DeleteFile( name + "noi" ) ;
				DeleteFile( name + "map" ) ;
				DeleteFile( name + "omf" ) ;
				DeleteFile( name + "rst" ) ;
				DeleteFile( name + "mem" ) ;
				break ;
			}

			case "rel":
			{
				if( m_fso.FileExists( name + "c" ) != false ) {
					DeleteFile( name + "asm" ) ;
					DeleteFile( name + "adb" ) ;
					DeleteFile( name + "lst" ) ;
					DeleteFile( name + "sym" ) ;
				}
				break ;
			}

			case "lib":
			{
				objs = m_shell.ExpandEnvironmentStrings( "%" + path + "_OBJS" + "%" ).replace(/[ \s]+/g, " ") ;

				Exec( "cscript //Nologo tool\\build.js clean " + objs ) ;
				break ;
			}
		}
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   C                                                                     
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: s                                                                  
// -------------------------------------------------------------------------------- 
function main()
{
	var		result ;


	if( WScript.Arguments( 0 ) != "clean" ) {
		result = Build() ;
	} else {
		result = Clean() ;
	}

	return result ;
}
